/*
 *	fram.c
 *
 *	ATARI VCS/EMU
 *
 *	* Tue Mar 15 20:31:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

// int/*%data*/ vcs_read(/*%addr*/)
asm("
	.code
	.align	1
	.global	vcs_read
vcs_read:
	xcmp	%r0, 0x0080		; $0000-$007F: TIA
	xjrlt	_vcs_read_tia
	xcmp	%r0, 0x0280		; $0080-$00FF: RAM(PIA), $0180-$01FF: RAM̃~[
	xjrlt	_vcs_read_mem
	xcmp	%r0, 0x0300		; $0280-$02FF: PIA
	xjrlt	_vcs_read_pia
	; /** FALLTHRU **/		; $0300-$F000: TIA,RAM,PIÃ~[, $F000-$FFFF: ROM
	;----------------------
_vcs_read_mem:
	ext	m6502mem@ah
	ext	m6502mem@al
	ld.ub	%r1, [%r0]
	ret
	;----------------------
_vcs_read_tia:
	xcall	m6502cpu_leave
	xcall.d	vcs_read_tia
	ld.w	%r12, %r0		; %r12 <- %addr
	xjp.d	m6502cpu_enter
	ld.w	%r1, %r10		; %r10 -> %data
	;----------------------
_vcs_read_pia:
	xcall	m6502cpu_leave
	xcall.d	vcs_read_pia
	ld.w	%r12, %r0		; %r12 <- %addr
	xjp.d	m6502cpu_enter
	ld.w	%r1, %r10		; %r10 -> %data
");

// void vcs_write(/*%addr,%data*/)
asm("
	.code
	.align	1
	.global	vcs_write
vcs_write:
	xcmp	%r0, 0x0080		; $0000-$007F: TIA
	xjrlt	_vcs_write_tia
	xcmp	%r0, 0x0280		; $0080-$00FF: RAM(PIA), $0180-$01FF: RAM̃~[
	xjrlt	_vcs_write_mem
	xcmp	%r0, 0x0300		; $0280-$02FF: PIA
	xjrlt	_vcs_write_pia
	ret				; $0300-$F000: TIA,RAM,PIÃ~[, $F000-$FFFF: ROM
	;----------------------
_vcs_write_mem:
	ext	m6502mem@ah
	ext	m6502mem@al
	ld.b	[%r0], %r1
	ret
	;----------------------
_vcs_write_tia:
	xcall.d	m6502cpu_leave
	ld.w	%r12, %r0		; %r12 <- %addr
	xcall.d	vcs_write_tia
	ld.w	%r13, %r1		; %r13 <- %data
	xjp	m6502cpu_enter
	;----------------------
_vcs_write_pia:
	xcall.d	m6502cpu_leave
	ld.w	%r12, %r0		; %r12 <- %addr
	xcall.d	vcs_write_pia
	ld.w	%r13, %r1		; %r13 <- %data
	xjp	m6502cpu_enter
");

